//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@BlbgGtFNg@v0.3
//@@@by iuser/5145841j
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@񓧉߃[hi 0: ͂̂܂܏óA1: 𔒔wiƂďój
#define NOT_ALPHA 0

//ڂ̃TvO
#define SAMP_NUM  7
#define BLUR_SIZE  0.8

#define SHADOW_WIDTH 0.1
#define TONE_CURVE 1.25


//@ڂ͈(TvO͌Œ̂߁A傫ƎȂo܂)
//@@ݒ 0.001953125i=2^-9j
float Extent
<
   string UIName = "Extent";
   string UIWidget = "Slider";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 0.01;
> = float( 0.001953125 );


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@`

//@_O^[Qbg̃NAl
#if NOT_ALPHA
float4 ClearColor = {1,1,1,1};
#else
float4 ClearColor = {0.5,0.5,0.5,0};
#endif
float ClearDepth  = 1.0;

//@|XgGtFNg錾
float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1.0,1.0};
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

// [xobt@
texture DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
>;

//@ANZTݒl擾
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha = MaterialDiffuse.a;

float scaling0 : CONTROLOBJECT < string name = "(self)"; >;
static float scaling = scaling0 * 0.1;

float3 ObjXYZ : CONTROLOBJECT < string name = "(self)"; string item = "XYZ"; >;

float3 ObjRxyz : CONTROLOBJECT < string name = "(self)"; string item = "Rxyz"; >;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

static float AspectRatio = (ViewportSize.x / ViewportSize.y);
static float2 SampStep = (float2(Extent,Extent)/ViewportSize*ViewportSize.y) * BLUR_SIZE;


//@ȏZX̂ڂʂL^邽߂̃_[^[Qbg
texture2D ScnMap2 : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1.0,1.0};
	int MipLevels = 1;
	string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp2 = sampler_state {
	texture = <ScnMap2>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// ʒ_VF[_
struct VS_OUTPUT {
	float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
	VS_OUTPUT Out = (VS_OUTPUT)0; 
	
	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	
	return Out;
}


//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Xڂ

float4 PS_passX( float2 Tex: TEXCOORD0 ) : COLOR {   
	float4 sum = 0;
	float e, n = 0, orgAlpha;
	
	[unroll]for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
		e = exp(-pow(i / (SAMP_NUM / 2.0), 2.0) / 2.0); //Kz
		sum += tex2D(ScnSamp, float2(Tex.x + SampStep.x * i, Tex.y)) * e;
		n += e;
	}
	
	sum /= n;
	orgAlpha = tex2D(ScnSamp, Tex).a;
	sum.a = max(tex2D(ScnSamp, Tex), sum.a);

	return sum;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// Yڂ + 

float4 PS_passY(float2 Tex: TEXCOORD0) : COLOR
{   
	const float4 ColorOrg = tex2D(ScnSamp, Tex);
	float4 Color, sum = 0, ShadowColor;
	float2 OblatePos = Tex;
	float e, n = 0;
	float dist, distMin, distMax, shadow, Oblateness;

	
	[unroll]for(int i = -SAMP_NUM; i <= SAMP_NUM; i++){
		e = exp(-pow(i / (SAMP_NUM / 2.0), 2.0) / 2.0); //Kz
		sum += tex2D(ScnSamp2, float2(Tex.x, Tex.y + SampStep.y * i)) * e;
		n += e;
	}
	
	Color = sum / n;
	Color.a = ColorOrg.a;	//@ɂ̓{JV͂ݏoȂꍇ
	//@܂Ń{JvZX

	distMin = 0.5 - scaling * SHADOW_WIDTH + ObjXYZ.x * scaling * SHADOW_WIDTH; //@ÂȂn߂鋗i0.5̉ʒ[j
	distMax = 0.5 + scaling * SHADOW_WIDTH + ObjXYZ.x * scaling * SHADOW_WIDTH; //@ÂȂI鋗i0.5̉ʒ[j

	Oblateness = 1.0 / lerp(AspectRatio, 1.0, ObjXYZ.y); //@ΕʔɌvZ
	OblatePos.y *= Oblateness;
	ShadowColor = float4(ObjRxyz * 57.4647887324, 1);

	dist = distance(OblatePos, float2(0.5, 0.5 * Oblateness)); // ʒ̋
	if(dist > distMax){			//@distMax Ȍ
		Color.rgb = ShadowColor;
		Color.a = 1.0;
	} else if(dist > distMin){
		//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
		//	distMini|n߁j distMaxiIjԂ̏
		//

		shadow = (dist - distMin) / (distMax - distMin);

		//@eɃg[J[u|邱ƂŃY`lϊ
		shadow = lerp(shadow / TONE_CURVE, shadow, shadow);

		//@e̔ZɔႵă{J
		Color.rgb = lerp(ColorOrg.rgb, Color.rgb, shadow);

		if(Color.a == 0) {
			Color.rgb = ShadowColor;
			Color.a = shadow;
		} else {
//			Color.rgb = Color.rgb * (1.0 - shadow) + ShadowColor * shadow;
//			Color.a = Color.a * (1 - shadow) + shadow;
			Color.rgb = Color.rgb + (ShadowColor - Color.rgb) * shadow;
			Color.a = Color.a + shadow - Color.a * shadow;
		}
	} else {
		Color = ColorOrg;
	}

	return lerp(ColorOrg, Color, alpha);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

technique Diffusion <
	string Script = 
		
		"RenderColorTarget0=ScnMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"ScriptExternal=Color;"
		
		"RenderColorTarget0=ScnMap2;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=Gaussian_X;"
		
		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=Gaussian_Y;"
	;
	
> {
	pass Gaussian_X < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_passDraw();
		PixelShader  = compile ps_2_0 PS_passX();
	}
	pass Gaussian_Y < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader  = compile ps_3_0 PS_passY();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
